%author		: Georg Kuschk
%function	: QR-Algorithmus
%arguments	: Matrix A , Shift lambda0
%result		: Vektor , welcher alle Eigenwerte der Matrix A sortiert enthaelt

function [lambdas] = qr_wilkinson(A,lambda0)

n=size(A,1);              %Dimension der Matrix als eindimensionale Zahl
Q=zeros(n);
R=zeros(n);
I=eye(n);

lambdas(1:n,1)=1;         %Vektor zum Aufnehmen der Eigenwerte
eigs=n;                   %Anzahl der insgesamt zu berechnenden Eigenwerte

A=hess(A);		  %Transformation auf Hessenbergform


while  n>0

  lambda=lambda0;
  k=1;
  abbruch = 1;

  while abbruch>eps                   %Abbruchkriterium siehe Vorlesung
      lambda=A(n,n);		      %zur Beschleunigung jedesmal den Eigenwert abschaetzen
      A=A-lambda*I;
      [Q,R]=qr(A);
      A=R*Q+lambda*I;

      abbruch = max(A(n,1:(n-1)));    %Abbruchkriterium : siehe Vorlesung

      k=k+1;
  end

  lambdas(eigs-n+1,1)=A(n,n);         %neu berechneten Eigenwert in den Ergebnisvektor aufnehmen

  n=n-1;			      %mit der kleineren Restmatrix fortfahren
  A=A(1:n , 1:n);
  I=eye(n);
end
