function ew=syev(A);
if nargin==0, A=[12 1 0 0 0;1 9 1 0 0;0 1 6 1 0;0 0 1 3 1;0 0 0 1 0]; end;
%
% Berechne alle Eigenwerte einer symmetrischen Matrix A
% mit Hilfe des QR-Verfahrens mit explizitem Shift nach Wilkinson
% und vorheriger Transformation auf Tridiagonalform
%
% falls kein A gegeben, dann benutze A aus Beispiel 6.17
%

% Transformation auf Tridiagonalform
AT=hess(A);

n=size(AT,1);
maxit=100*n;
ew=zeros(n,1);

anzit=0;
while n>1
    for it=1:maxit
        % Eigenwert genau genug?
        if abs(AT(n,n-1))<=10*eps*abs(AT(n,n)) break; end;
        
        % Eigenwerte von A(n-1:n,n-1:n) berechnen
        Ls(1,1)=sqrt((AT(n-1,n-1)+AT(n,n))^2-4*(AT(n-1,n-1)*AT(n,n)-...
            AT(n,n-1)*AT(n-1,n)))/2;
        Ls(2,1)=-Ls(1,1);
        Ls=Ls+(AT(n-1,n-1)+AT(n,n))/2;
        % Shift-Parameter nach Wilkinson:
        La=AT(n,n);
        if (abs(La-Ls(1))<abs(La-Ls(2))) L=Ls(1); else L=Ls(2); end;

        if n==2
            % letzte 2 Eigenwerte direkt einsetzen
            AT(1:2,1:2)=diag(Ls);
            break;
        end;

        % Shift
        for i=1:n AT(i,i)=AT(i,i)-L; end;
        
        [Q,R]=qr(AT(1:n,1:n));
        AT(1:n,1:n)=tril(R*Q,1);
        
        % Rueckshift
        for i=1:n AT(i,i)=AT(i,i)+L; end;
        anzit=anzit+1;
    end;
    if it>=maxit AT(1:n,1:n), error('QR did not converge'); end;
    ew(n)=AT(n,n);
    n=n-1;
end;
ew(1)=AT(1,1);
[sort(ew) sort(ew)-sort(eig(A))]

% Ergebnis:
%                 Eigenwerte   Fehler (vergl. mit eig)
%
%         -0.316875952616876     -1.11022302462516e-16
%           2.98386369683818     -8.88178419700125e-16
%                          6                         0
%           9.01613630316183        7.105427357601e-15
%           12.3168759526169     -5.32907051820075e-15
